/*Philip Street
  0716075
  Assignment 2 
*/
    
price(initial_markup1, 4).
price(initial_markup2, 3.5).
price(initial_markup3, 3).

price(over_10_markup, 0.95).
price(over_10_markup2, 0.93).
price(over_10_markup3, 0.86).
price(over_10_markup4, 0.89).

price(bw_5_and_10_markup, 0.93).
price(bw_5_and_10_markup2, 0.90).
price(bw_5_and_10_markup3, 0.85).
price(bw_5_and_10_markup4, 0.89).

price(under_5_markup, 0.89).
price(under_5_markup2, 0.85).
price(under_5_markup3, 0.83).
price(under_5_markup4, 0.85).

price(one_day, 1.5).
price(one_day2, 1).
price(one_day3, 1.2).

  
% Initial markup of the cost given by the mediator 
seller(Cost, DTS, [], Offer) :- 
	seller_aux1(Cost, DTS, Offer).


% if the bid is lower than the last given bid, do not decrement price 
seller(_, _, [-Bid, +LastOffer, -LastBid |_], LastOffer):-
	Bid < LastBid,
       	seller_writeln(['You are being Unreasonable.']),	% modified by Tsang
	seller_writeln(['My offer is the same as before.']). 	% modified by Tsang



% If the Offer is higher than the Bid, Offer new price - Else accept the Bid Price
seller(Cost, DTS, [-Bid | History], Offer) :-
	seller_aux(Cost, DTS, [-Bid | History], Offer),  % compute the intended Offer
	Offer > Bid.
seller(_, _, [-Bid | _], Bid).




% Setting initial prices based on the amount of days to sell
seller_aux1(Cost, DTS, Offer):-
	DTS >= 10,
	price(initial_markup1, IM),
	Offer is round(Cost * IM).

seller_aux1(Cost, DTS, Offer):-
	DTS < 10,
	DTS > 5,
	price(initial_markup2, IM2),
	Offer is round(Cost * IM2).

seller_aux1(Cost, DTS, Offer):-
	DTS =< 5,
	price(initial_markup3, IM3),
	Offer is round(Cost * IM3).



% if there are more than, or equal to 10 days left 
seller_aux(Cost, DTS, [-Bid, +LastOffer | _], Offer):-
	DTS >= 10,
	offer_above_10_days(Cost, Bid, LastOffer, Offer).

% if there are less than 10 days left, but more than 5 days left
seller_aux(Cost, DTS, [-Bid, +LastOffer | _], Offer):-
	DTS < 10,
	DTS >= 5,
        offer_bw_5_and_10_days(Cost, Bid, LastOffer, Offer).

% if there are less than 5 days left
seller_aux(Cost, DTS, [-Bid, +LastOffer |_], Offer):-
	DTS < 5,
	DTS > 1,
        offer_below_5_days(Cost, Bid, LastOffer, Offer).

% if there is one day left to sell
seller_aux(Cost, 1, [-Bid |_], Offer):-
	one_day_left(Cost, Bid, Offer).





% DTS are above 10
offer_above_10_days(_, Bid, LastOffer, Offer) :-
	Bid =< LastOffer / 2,
	Bid =< LastOffer / 4,
	price(over_10_markup, O10),
	Offer is round(LastOffer * O10).

offer_above_10_days(_, Bid, LastOffer, Offer) :-
	Bid =< LastOffer / 2,
	price(over_10_markup2, O10),
	Offer is round(LastOffer * O10).

offer_above_10_days(_, Bid, LastOffer, Offer) :-
	Bid >= LastOffer / 4,
	Bid >= LastOffer / 2,
	price(over_10_markup3, O10),
	Offer is round(LastOffer * O10).

offer_above_10_days(_, Bid, LastOffer, Offer) :-
	Bid >= LastOffer / 4,
	price(over_10_markup4, O10),
	Offer is round(LastOffer * O10).




% DTS are between 5 and 10
offer_bw_5_and_10_days(_, Bid, LastOffer, Offer) :-
	Bid =< LastOffer / 2,
	Bid =< LastOffer / 4,
	price(bw_5_and_10_markup, BW5_10),
	Offer is round(LastOffer * BW5_10). 

offer_bw_5_and_10_days(_, Bid, LastOffer, Offer) :-
	Bid =< LastOffer / 2,
	price(bw_5_and_10_markup2, BW5_10),
	Offer is round(LastOffer * BW5_10).

offer_bw_5_and_10_days(_, Bid, LastOffer, Offer) :-
	Bid >= LastOffer / 4,
	Bid >= LastOffer / 2,
	price(bw_5_and_10_markup3, BW5_10),
	Offer is round(LastOffer * BW5_10).

offer_bw_5_and_10_days(_, Bid, LastOffer, Offer) :-
	Bid >= LastOffer / 4,
	price(bw_5_and_10_markup4, BW5_10),
	Offer is round(LastOffer * BW5_10).



% DTS are below 5
offer_below_5_days(_, Bid, LastOffer, Offer) :-
	Bid =< LastOffer / 2,
	Bid =< LastOffer / 4,
	price(under_5_markup, U5),
	Offer is round(LastOffer * U5).

offer_below_5_days(_, Bid, LastOffer, Offer) :-
	Bid =< LastOffer / 2,
	price(under_5_markup2, U5),
 	Offer is round(LastOffer * U5).

offer_below_5_days(_, Bid, LastOffer, Offer) :-
	Bid >= LastOffer / 4,
	Bid >= LastOffer / 2,
	price(under_5_markup3, U5),
	Offer is round(LastOffer * U5).

offer_below_5_days(_, Bid, LastOffer, Offer) :-
	Bid >= LastOffer / 4,
	price(under_5_markup4, U5),
	Offer is round(LastOffer * U5).



% if the bid is less than the cost on the last day, up the offer to the cost price
one_day_left(Cost, Bid, Offer) :-
	Bid = Cost,
	price(one_day, ODL),
	Offer is round(Cost * ODL).

one_day_left(Cost, Bid, Offer) :-
	Bid < Cost / 2,
	price(one_day2, ODL),
	Offer is round(Cost * ODL).

one_day_left(Cost, Bid, Offer) :-
	Bid < Cost,
	Bid > Cost / 2,
	price(one_day3, ODL),
	Offer is round(Cost * ODL).

/* SELLER WRITE FUNCTIONS added by Edward Tsang */

seller_writeln(_) :-
	mediator_parameter(no_explanation),
	!.

seller_writeln([]) :-
	nl,
	!.

seller_writeln([H|T]) :-
	write(H),
	seller_writeln(T),
	!.
