'seller: parameter'(start_offer, 3).
'seller: parameter'(auto_accept_margin, 1.5).
'seller: parameter'(initial_target, 1.7).
'seller: parameter'(min_profit, 1.1).
'seller: parameter'(obv_drop, 1.25).
'seller: parameter'(obv_drop2, 0.65).
'seller: parameter'(default_drop, 0.9).
'seller: parameter'(default_drop2, 0.8).


seller(Cost, DTS, [], Offer):-              %Making the initial Offer

	'seller: parameter'(start_offer, Start_offer),
	DTS > 8,
	Offer is (Cost * Start_offer + (Cost*0.8)),
	DTS < 9,
	DTS > 5,
	Offer is (Cost * Start_offer + (Cost*0.6)),
	DTS > 2,
	DTS < 6,
	Offer is (Cost * Start_offer + (Cost*0.4)),
	
	seller_writeln(['+Seller: Initial offer is, (',Offer,')']).

 
seller(Cost, _, [Bid,_,_|_], Offer):-          %Criteria for Auto-Accept bid.
	
	'seller: parameter'(auto_accept_margin, Auto_accept_margin),
	Bidpos is -Bid,
	Bidpos >= (Cost * Auto_accept_margin),
	Offer = Bidpos,
	Profit is Bidpos - Cost,
	seller_writeln(['+Seller: Bid, ',Bidpos,', is automatically accepted, because Bid is ',Profit,' above cost.']).

seller(Cost, 9, [-Bid, +LastOffer, -LastBid|_],Offer):-
	
	'seller: parameter'(default_drop, Default_drop),
	Bidpos is -Bid,
	Bidpos < LastOffer,
	Offer is LastOffer * Default_drop.
	seller_writeln(['+Seller: Bid, ',Bidpos,', is not accepted']).

seller(Cost, 8, [-Bid, +LastOffer, -LastBid|_],Offer):-
	
	'seller: parameter'(default_drop, Default_drop),
	Bidpos is -Bid,
	Bidpos < LastOffer,
	Offer is LastOffer * Default_drop.
	seller_writeln(['+Seller: Bid, ',Bidpos,', is not accepted']).

seller(Cost, 7, [-Bid, +LastOffer, -LastBid|_],Offer):-
	
	'seller: parameter'(obv_drop2, Obv_drop2),
	Bidpos is -Bid,
	Bidpos < LastOffer,
	Offer is LastOffer * Obv_drop2.
	seller_writeln(['+Seller: i might be running out of time u see...']).

seller(Cost, 6, [-Bid, +LastOffer, -LastBid|_],Offer):-
	
	'seller: parameter'(default_drop2, Default_drop2),
	Bidpos is -Bid,
	Bidpos < LastOffer,
	Offer is LastOffer * Default_drop2.
	seller_writeln(['+Seller: Bid, ',Bidpos,' is not accepted']).


seller(Cost, DTS, [Bid|_], Offer):-      %Situations where the offer has to stall.
		
	'seller: parameter'(initial_target, Initial_target),
	Bidpos is -Bid,
	DTS < 5,!,
	Offercalc is Cost * Initial_target,
	(Offercalc > Bidpos,!,Offer = Offercalc;Offer = Bidpos),
	(DTS = 4, seller_writeln(['+Seller: target met, with 3 days left, stalling...']);
	DTS = 3, seller_writeln(['+Seller: target met, with 2 days left, stalling...'])).


seller(Cost, 2, [Bid|_], Offer):-           %Second last day.
	'seller: parameter'(auto_accept_margin, Auto_accept_margin),
	Bidpos is -Bid,
	Bidpos > Cost + (Auto_accept_margin//1.2),!,
 	Offer = Bidpos,
	Profit is Bidpos - Cost, 
	seller_writeln(['+Seller: last day but one; accept bid of ',Bidpos,', which is ',Profit,' above cost.']);
	
	'seller: parameter'(obv_drop, Obv_drop),
	Offer is Cost * Obv_drop,
	seller_writeln(['+Seller: last day but one; lure buyer to agree on a deal by performing an obvious drop in offer price to ', Offer]).




seller(Cost, 1, [Bid|_], Offer):-	     %Last day.
	
	'seller: parameter'(min_profit, Min_profit),
	Bidpos is -Bid,
	Bidpos > (Cost * Min_profit),
	Offer = Bidpos,
	Profit is Bidpos - Cost,
	seller_writeln(['+Seller: last chance! accept bid of ',Bidpos,', which is ',Profit,' above cost.']);
	
	seller_writeln(['+Seller: cannot make a deal as I will not sell without satisfying a certain profit. Sorry!']),
	Offer is Cost + 1.
	
 

 

 

 

 

 

 
/*----------------------------------------------------------------------*/

seller_writeln(_) :- mediator_parameter(no_explanation), !.

                /* no output if mediator suppresses reasoning */

seller_writeln([]) :- nl, !.

seller_writeln([H|T]) :- write(H), seller_writeln(T), !.

 

/*----------------------------------------------------------------------*/
